#!/usr/bin/perl
use Test::More tests => 26;
use POWER::Epoll;
use Errno;
use Data::Dumper;
no warnings 'once';
require "t/init";

syswrite W, $buf or die $!;
($status, $result) = epoll_wait($epfd, 0);
is($status, 2, '2 fd ready (status)');
is($#$result, 1, '2 fd ready (result)');
#@{$result}[0,1] = @{$result}[1,0] if $result->[0][0] != fileno(R);
is($result->[0][0], fileno(R), 'got R');
is($result->[0][1], EPOLLIN, 'R = IN');
is($result->[1][0], fileno(W), 'got W');
is($result->[1][1], EPOLLOUT, 'W = OUT');

($status, $result) = epoll_wait($epfd, 0);
is($status, 0, '0 fd ready (status)');
is($#$result, -1, '0 fd ready (result)');

$n = sysread R, $buf, 102400 or die $!;
is($n, $size, 'read $size data');

($status, $result) = epoll_wait($epfd, 0);
is($status, 1, '1 fd ready (status)');
is($#$result, 0, '1 fd ready (result)');
is($result->[0][0], fileno(W), 'got W');
is($result->[0][1], EPOLLOUT, 'W = OUT');

syswrite W, $buf or die $!;
($status, $result) = epoll_wait($epfd, 0);
is($result->[0][0], fileno(R), 'got R');
is($result->[0][1], EPOLLIN, 'R = IN');
is($result->[1][0], fileno(W), 'got W');
is($result->[1][1], EPOLLOUT, 'W = OUT');

$n = sysread R, $buf, 1 or die $!;
($status, $result) = epoll_wait($epfd, 0);
is($status, 0, '0 fd ready (status) -- partial read');
is($#$result, -1, '0 fd ready (result) --- partial read');

$n = sysread R, $buf, 102400 or die $!;
ok($n, 'complete partial read');
$n = sysread R, $buf, 102400;
ok((not defined $n and $!{EAGAIN}), 'next read: got EAGAIN');
($status, $result) = epoll_wait($epfd, 0);
is($result->[0][0], fileno(W), 'got W');
is($result->[0][1], EPOLLOUT, 'W = OUT');

#print Dumper [$status, $result];

